/** Fichier station.c **/

/******************************************************************/
/** Serveur pour la station de pollution                         **/
/******************************************************************/

/** Fichiers d'inclusion **/
#include <getopt.h>
#include "libcom.h"
#include "libthrd.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <dirent.h> 
#include <stddef.h>
#include <fcntl.h>
#include <errno.h>
#include <netdb.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <poll.h>
/** Constantes **/
#define MAX_LIGNE 2048
#define MAX_TAMPON 1024
#define MAX_UDP_MESSAGE 256


/** Variables publiques **/
typedef struct{
	int Recent;
	int Deleted;
 
}nombre_flags;

/** Variables statiques **/

/** Procedure principale **/

//int s=3;
int adresse=0;

/*************************************Verif LOGIN****************************/

int VerifLogin(char * arg1,char * arg2,int login_ok)
{
	FILE * monFichier=NULL;
	monFichier = fopen("LOGIN.txt", "r");
	char login[MAX_LIGNE]="";
	if (monFichier != NULL)
    {	
		strcat(arg1,"\n");
        while (fgets(login, MAX_LIGNE, monFichier) != NULL) // On lit le fichier tant qu'on ne reçoit pas d'erreur (NULL)
        {
            //printf("%s", login); // On affiche la chaîne qu'on vient de lire
			if (strcmp(arg1,login) == 0)
			{
				login_ok=1;
			}
        }
		
        fclose(monFichier);
		return login_ok;
    }
    else
    {
        // On affiche un message d'erreur si on veut
        printf("Impossible d'ouvrir le fichier test.txt");
    }

	fclose (monFichier);
	
	return 0;
}
/*************************************Nombres de mail***************************************/

int Nombre_mail(char * user,int nb_mail)
{
	nb_mail=0;
	char Chemin[MAX_LIGNE]="";
	sprintf(Chemin,"../Messages/Utilisateur/%s/INBOX",user);
	printf("CHEMIN nb mail: %s\n",Chemin);
   DIR *rep = opendir (Chemin); 
 
   if (rep != NULL) 
   { 
      struct dirent *lecture; 
 
      while ((lecture = readdir (rep))) 
      { 
         nb_mail=nb_mail+1;

      } 
      printf("* %d EXISTS \n ",(nb_mail-2)/2);
      closedir (rep), rep = NULL; 
   } 
   return (nb_mail-2)/2;
}

/************************************LECTURE FLAGS******************************************/

nombre_flags Lect_Flags(char * user,int nb_RECENT,nombre_flags nombre_flag,int nb_mail,int *tab_sup,int *tab_sup2)
{
	nombre_flag.Recent=0;
	nombre_flag.Deleted=0;
	//nb_RECENT=0;
	char Chemin[MAX_LIGNE]="";
	char Recent[MAX_LIGNE]="\\RECENT\n";
	char Deleted[MAX_LIGNE]="\\DELETED\n";
	int i;
	int j=0;
	int k=0;
	for ( i = 1; i < nb_mail+1; i++) 
	{
		FILE * monFichier=NULL;
		sprintf(Chemin,"../Messages/Utilisateur/%s/INBOX/%d.status",user,i);
		printf("CHEMIN recent: %s\n",Chemin);

		monFichier = fopen(Chemin, "r");
		char msg_recu[MAX_LIGNE]="";
		if (monFichier != NULL)
   		{	
			while (fgets(msg_recu, MAX_LIGNE, monFichier) != NULL) // On lit le fichier tant qu'on ne reçoit pas d'erreur (NULL)
			{
				if (strcmp(Recent,msg_recu) == 0)
				{
					nombre_flag.Recent=nombre_flag.Recent+1;
					tab_sup[j]=i;
					j=j+1;
					printf("it's ok RECENT\n");
				}
				if (strcmp(Deleted,msg_recu) == 0)
				{
					nombre_flag.Deleted=nombre_flag.Deleted+1;
					tab_sup2[k]=i;
					k=k+1;
					printf("it's ok DELETED\n");
				}

			}
			
			fclose(monFichier);

		}
		else
		{
			// On affiche un message d'erreur si on veut
			printf("Impossible d'ouvrir les mails de %s \n",user);
		}
	}	
	
	return nombre_flag;

}	
/************************************Supprimer Ligne******************************************/	
	
int Sup_Ligne(char * user,char * Flag, int num_mail) //num status = numero du .status a supprimer le Flag
{
	char Chemin[MAX_LIGNE]="";
	char Chemintemp[MAX_LIGNE]="";

	FILE * monFichier=NULL;
	FILE * monFichiertemp=NULL;
		sprintf(Chemin,"../Messages/Utilisateur/%s/INBOX/%d.status",user,num_mail);
		sprintf(Chemintemp,"../Messages/Utilisateur/%s/INBOX/%dtemp.status",user,num_mail);

		printf("CHEMIN sup ligne : %s\n",Chemin);
		printf("CHEMIN sup ligne : %s\n",Chemintemp);


		monFichier = fopen(Chemin, "r+");
		
		monFichiertemp = fopen(Chemintemp, "w");
		char msg_recu[MAX_LIGNE]="";
		if ((monFichier != NULL)|(monFichiertemp != NULL))
   		{	
			while (fgets(msg_recu, MAX_LIGNE, monFichier) != NULL) // On lit le fichier tant qu'on ne reçoit pas d'erreur (NULL)
			{
				if (strcmp(Flag,msg_recu) != 0)
				{
					fputs(msg_recu, monFichiertemp);
					printf("ok");
					//fwrite(msg_recu,1,sizeof(msg_recu),monFichiertemp);
					//fprintf(monFichiertemp,"%s",msg_recu);
				}
			}
			
			fclose(monFichier);
			fclose(monFichiertemp);
		
		}
		else
		{
			printf("Erreur ouverture fichier sup\n");
		}
		
	if (remove(Chemin) == 0)
	{
		printf("fichier supprimer\n");
	}

	else
	{
		printf("fichier Non supprimer\n");
	}	
	rename(Chemintemp,Chemin);
	return 0;
}


/*************************************GESTION CLIENT ***************************************/

int gestionClientTCP(int s)
{
	//int s=*(int *)arg;
	/* Obtient une structure de fichier */
	FILE *dialogue=fdopen(s,"a+"); // acces à un fichier en mode lecture et écriture et append (ne pas écraser)
	if(dialogue==NULL){ perror("gestionClientTCP.fdopen"); exit(EXIT_FAILURE); }

	/* Echo */
	char ligne[MAX_LIGNE];
	char tag[MAX_LIGNE],fct[MAX_LIGNE],arg1[MAX_LIGNE],arg2[MAX_LIGNE];
	char buffer[MAX_LIGNE]="OK IMAP2 Server Ready \n\r";
	char reponse_log1[MAX_LIGNE]="A001 OK User logged in \n";
	char reponse_log2[MAX_LIGNE]="LOGIN_ERROR\n";
	char reponse_log3[MAX_LIGNE]="FONCTION_ERROR\n";
	char reponse_log4[MAX_LIGNE]="A007 OK Logout complete\n";
	char reponse_log5[MAX_LIGNE]="OK NOOP\n";
	char reponse_log6[MAX_LIGNE]="";
	char reponse_log7[MAX_LIGNE]="";
	char reponse_log8[MAX_LIGNE]="ERROR MAILBOX does not exist\n";

	char Chemin[MAX_LIGNE]="";
	char user[MAX_LIGNE]="";
	char Flag[MAX_LIGNE]="";
	char Flag_R[MAX_LIGNE]="\\RECENT\n";
	char Flag_S[MAX_LIGNE]="\\SEEN\n";
	char Flag_D[MAX_LIGNE]="\\DELETED\n";
	char Flag_A[MAX_LIGNE]="\\ANSWERED\n";
	char Flag_F[MAX_LIGNE]="\\FLAGGED\n";

	nombre_flags nombre_flag_t;
	
	int login_ok=0;
	int nb_mail;
	int nb_RECENT;
	int tab_sup[MAX_LIGNE]={0};
	int tab_sup2[MAX_LIGNE]={0};
	int i;

	fwrite(buffer,1,sizeof(buffer),dialogue);

	while(fgets(ligne,MAX_LIGNE,dialogue) !=NULL)//while(fgets(ligne,MAX_LIGNE,dialogue)) //while(fgets(ligne,MAX_LIGNE,dialogue) !=NULL && strlen(ligne) < 3)
	{	
		sscanf(ligne,"%s %s %s %s",tag,fct,arg1,arg2 );//a finir
		//printf("tag: %s fct: %s arg1: %s arg2: %s \n",tag,fct,arg1,arg2 );
		//printf("ligne=%s\n",ligne);

		if (strcmp(fct, "LOGIN") == 0) 
		{
		sprintf(user,"%s",arg1);	
		printf("A001 OK\n");
		login_ok=VerifLogin(arg1,arg2,login_ok);
		if ((login_ok==1) && (strcmp(arg2, "") != 0))
			{
				//strcat(user,arg1);
				//sprintf(user,"%s",arg1);
				
				fwrite(reponse_log1,1,sizeof(reponse_log1),dialogue);
				login_ok=0;
				while (1)
				{
					fgets(ligne,MAX_LIGNE,dialogue);
					sscanf(ligne,"%s %s %s %s",tag,fct,arg1,arg2 );
					printf("%s",ligne);

					if (strcmp(fct, "LOGOUT") == 0) 
					{
						fwrite(reponse_log4,1,sizeof(reponse_log4),dialogue);
						break;
					}

					if (strcmp(fct, "NOOP") == 0) 
					{
						printf("noop envoyé \n");
						fwrite(reponse_log5,1,sizeof(reponse_log5),dialogue);
					}

					if (strcmp(fct, "SELECT") == 0) 
					{
						printf("SELECT \n");
						nb_mail=Nombre_mail(user,nb_mail);
						nombre_flag_t=Lect_Flags(user,nb_RECENT,nombre_flag_t,nb_mail,tab_sup,tab_sup2);
						
						if (nb_mail != -1)
						{
						printf("nombre RECENT : %d\n",nombre_flag_t.Recent);

						sprintf(reponse_log6,"* %d EXISTS\n",nb_mail);
						sprintf(reponse_log7,"* %d RECENT\n",nombre_flag_t.Recent);
						fwrite(reponse_log6,1,sizeof(reponse_log6),dialogue);
						fwrite(reponse_log7,1,sizeof(reponse_log7),dialogue);

						strcpy(Flag,Flag_R);
						for (i=0;i<nombre_flag_t.Recent;i++)
						{
							printf("%d\n",tab_sup[i]);
							Sup_Ligne(user,Flag,tab_sup[i]);
						}
						//break;
						}
						else
						{
							fwrite(reponse_log8,1,sizeof(reponse_log8),dialogue);
						}
						
					}

						if (strcmp(fct, "CHECK") == 0) 
					{
						printf("CHECK \n");
						nb_mail=Nombre_mail(user,nb_mail);
						nombre_flag_t=Lect_Flags(user,nb_RECENT,nombre_flag_t,nb_mail,tab_sup,tab_sup2);
						if (nb_mail != -1)
						{
						printf("nombre RECENT : %d\n",nombre_flag_t.Recent);

						sprintf(reponse_log6,"* %d EXISTS\n",nb_mail);
						sprintf(reponse_log7,"* %d RECENT\n",nombre_flag_t.Recent);
						fwrite(reponse_log6,1,sizeof(reponse_log6),dialogue);
						fwrite(reponse_log7,1,sizeof(reponse_log7),dialogue);
						
						strcpy(Flag,Flag_R);
						for (i=0;i<nombre_flag_t.Recent;i++)
						{
							printf("%d\n",tab_sup[i]);
							Sup_Ligne(user,Flag,tab_sup[i]);
						}
						
						
						//break;
						}
						else
						{
							fwrite(reponse_log8,1,sizeof(reponse_log8),dialogue);
						}

					}
						if (strcmp(fct, "EXPUNGE") == 0) 
					{
						printf("EXPUNGE \n");
						nb_mail=Nombre_mail(user,nb_mail);
						nombre_flag_t=Lect_Flags(user,nb_RECENT,nombre_flag_t,nb_mail,tab_sup,tab_sup2);

						if (nb_mail != -1)
						{
						printf("nombre DELETED : %d\n",nombre_flag_t.Deleted);

						sprintf(reponse_log6,"* %d EXISTS\n",nb_mail);
						sprintf(reponse_log7,"* %d DELETED\n",nombre_flag_t.Deleted);
						fwrite(reponse_log6,1,sizeof(reponse_log6),dialogue);
						fwrite(reponse_log7,1,sizeof(reponse_log7),dialogue);
						
						strcpy(Flag,Flag_D);
						for (i=0;i<nombre_flag_t.Deleted;i++)
						{
							printf("%d\n",tab_sup2[i]);
							//Sup_Ligne(user,Flag,tab_sup2[i]);
							printf("fichier contient : %d\n",tab_sup2[i]);
							sprintf(Chemin,"../Messages/Utilisateur/%s/INBOX/%d.status",user,tab_sup2[i]);
							remove(Chemin);
							sprintf(Chemin,"../Messages/Utilisateur/%s/INBOX/%d.txt",user,tab_sup2[i]);
							remove(Chemin);
						}
						nb_mail=Nombre_mail(user,nb_mail);
						sprintf(reponse_log6,"* %d EXISTS\n",nb_mail);
						fwrite(reponse_log6,1,sizeof(reponse_log6),dialogue);
						
						//break;
						}
						else
						{
							fwrite(reponse_log8,1,sizeof(reponse_log8),dialogue);
						}
						
					}


				}
			}
			else
			{
				fwrite(reponse_log2,1,sizeof(reponse_log2),dialogue);
			}
		}
		else
		{
			fwrite(reponse_log3,1,sizeof(reponse_log3),dialogue);
		}
				

	}
	


	/* Termine la connexion */
	fclose(dialogue);
	printf("client déconnecté\n");
	return 0;
}


int multi_gestionClientTCP(int s)
{
	//int dialogue= s;
	lanceThread(gestionClientTCP,(int) s,0);
	return 0;
}


void serveur_TCP(void)
{
	int s=0;
	char *port="993"; // faire attention à ne pas choisir un port utilisé par le système
	int connexions= 6; //maximum 6 clients dans la file d'attente TCP


	/* Initialisation du serveur */
	s=initialisationServeurTCP(port,connexions);

	/* Lancement de la boucle d'ecoute */
	//boucleServeurTCP(s,gestionClientTCP);
	boucleServeurTCP(s,multi_gestionClientTCP);


	/* On termine la connexion */
	shutdown(s,SHUT_RDWR);


}


int main(int argc,char *argv[])
{
	serveur_TCP();
	return 0;
}
